% La fonction "championne" simule le championnat de basket et renvoie le
% numéro associé à l'équipe championne.
function ch = championne ()
% On désigne par "Neq" le nombre d'équipes en lice.
Neq = 16;
% "victoires(a)" est le nombre de matchs remportés par l'équipe a.
victoires = zeros (1, Neq);
% On fait jouer chaque équipe contre l'autre une fois.
for i = 1 : Neq
    for j = i + 1 : Neq
        % On simule le résultat du match, et on met à jour "victoires" en
        % fonction.
        if rand () < pvict (i, j)
            victoires(i) = victoires(i) + 1;
        else
            victoires(j) = victoires(j) + 1;
        end
    end
end
% Une méthode pour départager uniformément les ex-æquo est d'ajouter une
% partie fractionnaire aléatoire à chaque score.
victoires = victoires + rand (1, Neq);
% On regarde qui a le plus de victoires.
[~, ch] = max (victoires);
% On renvoie l'identité de la championne.
return
end
