% La fonction "keno_v2" fait le même travail que "keno_IC", mais avec un
% code amélioré au niveau du calcul des gains, qu'on pré-réalise avant la
% boucle.
function keno_v2 ()
Nsim = 1000000;
Ncoch = 16;
total = 0;
total_carres = 0;
% "tableau_gains(s + 1)" sera la valeur du gain pour un score de s. On le
% calcule une fois pour toutes à l'aide de la fonction auxiliaire
% "calcul_gains".
tableau_gains = calcul_gains ();
for i = 1 : Nsim
    carton = 1 : Ncoch;
    % "legain" est le gain obtenu par le joueur. Comme on va l'utiliser
    % deux fois, on doit le stocker dans une variable d'abord.
    legain = tableau_gains(score (carton, tirage ()) + 1);
    total = total + legain;
    total_carres = total_carres + legain * legain;
end
moyenne = total / Nsim;
variance_gain = total_carres / Nsim - moyenne * moyenne;
ect_estimtr = sqrt (variance_gain / Nsim);
c0 = sqrt (2) * erfinv (-.90);
c1 = sqrt (2) * erfinv (+.998);
fprintf ('Avec un risque de 1 ‰ pour la sous-estimation, ')
fprintf ('resp. de 5 %% pour la surestimation,\n');
fprintf ('l''espérance de gain du Keno se situe dans l''intervalle ');
fprintf ('[%f, %f] €.\n', moyenne + c0 *ect_estimtr, ...
    moyenne + c1 * ect_estimtr);
return
end
