% La fonction "keno_v3" fait le même travail que "keno_v2", mais avec un
% code encore amélioré, où on ne simule les numéros tirés que parmi ceux
% qui sont cochés.
function keno_v3 ()
Nsim = 1000000;
Ncoch = 16;
total = 0;
total_carres = 0;
tableau_gains = calcul_gains ();
for i = 1 : Nsim
    % La fonction "tirage_reduit" donne quels numéros ont été tirés parmi
    % ceux qu'on a cochés; on stocke son résultat dans "letirage".
    letirage = tirage_reduit ();
    % "lescore" est le score obtenu, qui se déduit facilement de letirage.
    lescore = sum ((1:Ncoch) .* letirage);
    legain = tableau_gains(lescore + 1);
    total = total + legain;
    total_carres = total_carres + legain * legain;
end
moyenne = total / Nsim;
variance_gain = total_carres / Nsim - moyenne * moyenne;
ect_estimtr = sqrt (variance_gain / Nsim);
c0 = sqrt (2) * erfinv (-.90);
c1 = sqrt (2) * erfinv (+.998);
fprintf ('Avec un risque de 1 ‰ pour la sous-estimation, ')
fprintf ('resp. de 5 %% pour la surestimation,\n');
fprintf ('l''espérance de gain du Keno se situe dans l''intervalle ');
fprintf ('[%f, %f] €.\n', moyenne + c0 *ect_estimtr, ...
    moyenne + c1 * ect_estimtr);
return
end
