% La fonction "lapin" estime l'aire du lapin de Douady par la méthode de
% Monte-Carlo, en échantillonnant selon la loi uniforme sur le carré
% [-2,2]×[-2,2].
function lapin
% "Nsim" est le nombre de simulations.
Nsim = 15000000;
% "somme" est la somme des simulations effectuées.
somme = 0;
% Boucle de Monte-Carlo.
for i = 1 : Nsim
    % On tire z uniformément sur le carré [-2,2]×[-2,2].
    z = (-2 + rand () * 4) + (-2 + rand () * 4) * 1i;
    % Calcule la fonction dont on prendra l'espérance. La fonction
    % "enlapin" renvoie 1 si on est dans le lapin, et 0 sinon.
    somme = somme + enlapin (z) * 16;
end
% "moyenne" est la moyenne des simulations effectuées.
moyenne = somme / Nsim;
% Affichage du résultat.
fprintf ('L''aire du lapin de Douady est estimée à ');
fprintf ('%f.\n', moyenne);
end
