% La fonction "diffstrategieCX" renvoie, dans une situation couplée, +1
% quand la stratégie de Charlotte a réussi mais pas celle de Xénia, -1
% quand c'est l'inverse, et 0 sinon.
function diff = diffstrategieCX ()
% On alloue directement la mémoire pour "source", sachant qu'on aura besoin
% d'au plus 15 valeurs.
source = zeros (1, 15);
% On commence par regarder ce que donne la stratégie de Charlotte. Les
% tirages de dés que nous serons amenés à faire seront stockés dans
% "source".
des = ceil (6 * rand (1, 5));
% Ce lancer de dés initial constitue évidemment les 5 premières valeurs de
% la source.
source (1: 5) = des;
% La variable "donnees_puisees" nous indique combien on a déjà tiré de dés
% dans "source".
donnees_puisees = 5;
% On passe aux dés à relancer.
for i = 1: 2
    choix = choixC (i, des);
    for j = 1: 5
        if (choix(j))
            % "r" est le résultat du dé supplémentaire tiré.
            r = ceil (6 * rand ());
            % On met ce résultat supplémentaire dans la source de données.
            donnees_puisees = donnees_puisees + 1;
            source(donnees_puisees) = r;
            des(j) = r;
        end
    end
end
% On stocke le résultat de Charlotte dans "resultatC".
resultatC = (sum (des) >= 24);
% On stocke aussi le nombre total de donnees écrites, dans
% "donnees_ecrites".
donnees_ecrites = donnees_puisees;
% Maintenant on regarde ce que donne la stratégie de Xénia. Toute l'astuce
% est qu'on utilisera la source de données déjà utilisée par Charlotte,
% autant que possible!
des = source (1: 5);
donnees_puisees = 5;
for i = 1: 2
    choix = choixX (i, des);
    for j = 1: 5
        if choix(j)
            % Observez comment on va forcer le couplage en allant lire dans
            % "source" quand c'est possible.
            if donnees_puisees < donnees_ecrites
                r = source(donnees_puisees + 1);
                donnees_puisees = donnees_puisees + 1;
            else
                r = ceil (6 * rand ());
            end
            des(j) = r;
        end
    end
end
resultatX = (sum (des) >= 24);
diff = resultatC - resultatX;
return
end